﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MapleLib.WzLib.WzStructure.Data
{
    public static class FieldTypeExtensions
    {
        public static string ToReadableString(this FieldType str)
        {
            string name = str.ToString().Replace("FIELDTYPE_", "");
            string mostLower = name.Substring(0, 1) + name.Substring(1).ToLower(); // only cap on the first character

            mostLower += string.Format(" = {0}", (int) str); 

            return mostLower;
        }
    }

    public enum FieldType
    {        
        // for older versions, probably not accurate anyway
        FIELDTYPE_FISHINGKING = 0x4A,
        FIELDTYPE_SHOWABATH = 0x51,
        FIELDTYPE_BEGINNERCAMP = 0x52,
        FIELDTYPE_SNOWMAN = 1000, // 0x3E8
        FIELDTYPE_SHOWASPA = 1001, // 0x3E9
        FIELDTYPE_HORNTAILPQ = 1013, // 0x3F5
        FIELDTYPE_CRIMSONWOODPQ = 1014, // 0x3F6

        // up till v188
        FIELDTYPE_DEFAULT = 0x0,
        FIELDTYPE_SNOWBALL = 0x1,
        FIELDTYPE_CONTIMOVE = 0x2,
        FIELDTYPE_TOURNAMENT = 0x3,
        FIELDTYPE_COCONUT = 0x4,
        FIELDTYPE_OXQUIZ = 0x5,
        FIELDTYPE_PERSONALTIMELIMIT = 0x6,
        FIELDTYPE_WAITINGROOM = 0x7,
        FIELDTYPE_GUILDBOSS = 0x8,
        FIELDTYPE_LIMITEDVIEW = 0x9,
        FIELDTYPE_MONSTERCARNIVAL_S2 = 0xA,
        FIELDTYPE_MONSTERCARNIVALREVIVE = 0xB,
        FIELDTYPE_ZAKUM = 0xC,
        FIELDTYPE_ARIANTARENA = 0xD,
        FIELDTYPE_DOJANG = 0xE,
        FIELDTYPE_MONSTERCARNIVAL_NOT_USE = 0xF,
        FIELDTYPE_MONSTERCARNIVALWAITINGROOM = 0x10,
        FIELDTYPE_COOKIEHOUSE = 0x11,
        FIELDTYPE_BALROG = 0x12,
        FIELDTYPE_BATTLEFIELD = 0x13,
        FIELDTYPE_SPACEGAGA = 0x14,
        FIELDTYPE_WITCHTOWER = 0x15,
        FIELDTYPE_TUTORIAL = 0x16,
        FIELDTYPE_MASSACRE = 0x17,
        FIELDTYPE_MASSACRE_RESULT = 0x18,
        FIELDTYPE_PARTYRAID = 0x19,
        FIELDTYPE_PARTYRAID_BOSS = 0x1A,
        FIELDTYPE_PARTYRAID_RESULT = 0x1B,
        FIELDTYPE_NODRAGON = 0x1C,
        FIELDTYPE_DYNAMICFOOTHOLD = 0x1D,
        FIELDTYPE_ESCORT = 0x1E,
        FIELDTYPE_ESCORT_RESULT = 0x1F,
        FIELDTYPE_HUNTINGADBALLOON = 0x20,
        FIELDTYPE_CHAOSZAKUM = 0x21,
        FIELDTYPE_KILLCOUNT = 0x22,
        FIELDTYPE_PVP = 0x24,
        FIELDTYPE_WAITINGPARTYQUEST = 0x25,
        FIELDTYPE_DEFENSE = 0x26,
        FIELDTYPE_JULDARIGI = 0x27,
        FILEDTYPE_LITTLEINDIAN = 0x28,
        FIELDTYPE_CASHMINIDUNGEON = 0x29,
        FIELDTYPE_CONQUEST = 0x2A,
        FIELDTYPE_CONQUEST_WAITINGPARTY = 0x2B,
        FIELDTYPE_MPARKBONUS = 0x2C,
        FIELDTYPE_HILLAH = 0x2D,
        FIELDTYPE_RANDOMDROP = 0x2E,
        FIELDTYPE_SUMMONEVENT = 0x2F,
        FIELDTYPE_GILSSAM = 0x30,
        FIELDTYPE_MULTISTAGE = 0x31,
        FIELDTYPE_BASEBALLDROP = 0x32,
        FIELDTYPE_DEATHCOUNT = 0x33,
        FIELDTYPE_COOK = 0x34,
        FIELDTYPE_FLYINGKITEDROP = 0x35,
        FIELDTYPE_WEDDING = 0x3C,
        FIELDTYPE_WEDDINGPHOTO = 0x3D,
        FIELDTYPE_RHYTHMGAME = 0x42,
        FIELDTYPE_FPSMODE = 0x43,
        FIELDTYPE_MOUNTAINRIDING = 0x44,
        FIELDTYPE_FABRESNIPING = 0x45,
        FIELDTYPE_PIRANHA = 0x46,
        FIELDTYPE_ROBBINS = 0x47,
        FIELDTYPE_FALLINGSTONE = 0x48,
        FIELDTYPE_HEKATON = 0x49,
        FIELDTYPE_ZEROTUTORIAL = 0x4A,
        FIELDTYPE_BOSSARENA = 0x4B,
        FIELDTYPE_INVASION = 0x4C,
        FIELDTYPE_SPACEMOONRABBIT = 0x51,
        FIELDTYPE_CATAPULT = 0x52,
        FIELDTYPE_SPACEMOONRABBIT_BONUS = 0x53,
        FIELDTYPE_CAPTURE_THE_FLAG = 0x54,
        FIELDTYPE_HUNDREDBINGO = 0x55,
        FIELDTYPE_BONUSREWARD = 0x56,
        FIELDTYPE_TYPINGGAME = 0x57,
        FIELDTYPE_HUNDREDOXQUIZ = 0x58,
        FIELDTYPE_CUSTOMIMPACT_PORTAL_USABLE = 0x59,
        FIELDTYPE_COORDY = 0x5A,
        FIELDTYPE_SAD = 0x5F,
        FIELDTYPE_SOUL = 0x60,
        FIELDTYPE_STARPLANETRPS = 0x64,
        FIELDTYPE_SIDESCROLLFLYSHOOTING = 0x66,
        FIELDTYPE_FPSMODE_LEAFGAME = 0x67,
        FIELDTYPE_STARPLANETBATTLE = 0x6C,
        FIELDTYPE_RUNNING_GAME = 0x6D,
        FIELDTYPE_MOMENTSWIMAREA = 0x72,
        FIELDTYPE_VERTICAL_RUNAWAY = 0x73,
        FIELDTYPE_12TH_TRESURE = 0x74,
        FIELDTYPE_12TH_TRESURE_SAT = 0x75,
        FIELDTYPE_PIGGY_BAR = 0x76,
        FIELDTYPE_URUS = 0x79,
        FIELDTYPE_DOJANGMINDBODYTRAINING = 0x7A,
        FIELDTYPE_GHOST_PARK = 0x7B,
        FIELDTYPE_COW_GAME = 0x7C,
        FIELDTYPE_FPSMODE_LEAFGAME_KR = 0x7D,
        FIELDTYPE_MINIGAME_PINBALL_KR = 0x7E,
        FIELDTYPE_ROLEPLAYING_KR = 0x7F,
        FIELDTYPE_POLOFRITOBOUNTYHUNTING = 0x80,
        FIELDTYPE_POLOFRITOTOWNDEFENSE = 0x81,
        FIELDTYPE_POLOFRITOKILLMONSTER = 0x82,
        FIELDTYPE_POLOFRITOEAGLEHUNTING = 0x83,
        FIELDTYPE_POLOFRITOSTEALDRAGONSEGG = 0x84,
        FIELDTYPE_POLOFRITOCOURTSHIPDANCE = 0x85,
        FIELDTYPE_POLOFRITOFLAMEWOLF = 0x87,
        FIELDTYPE_WADDLER = 0x89,
        FIELDTYPE_KAPUS = 0x8D,
        FIELDTYPE_TRADEKING = 0x8E,
        FIELDTYPE_PLATPORMER_OXYGEN = 0x8F,
        FIELDTYPE_DEMIAN = 0x90,
        COUNT_OF_FIELDTYPE = 0x91,

    }
}
